package org.freecompany.util.multicaster;

import static java.lang.Thread.UncaughtExceptionHandler;

/**
 * Handles threading exceptions by distributing them to a collection
 * queue for processing by the framework.
 */
public class ExceptionHandler implements UncaughtExceptionHandler {

	protected Notification listener = NotificationMulticaster.empty();

	public ExceptionHandler() {
	}

	public ExceptionHandler( final Notification listener) {
		addListener( listener);
	}

	public void addListener( final Notification listener) {
		this.listener = NotificationMulticaster.add( this.listener, listener);
	}

	public void removeListener( final Notification listener) {
		this.listener = NotificationMulticaster.remove( this.listener, listener);
	}

	public void uncaughtException( final Thread thread, final Throwable t) {
		listener.severe( t, thread);
	}
}
