package org.freecompany.util.multicaster;

/**
 * Generic interface for notification systems.  This interface uses the general
 * event level types from the core logging system.
 */
public interface Notification {

	void debug( Throwable t, Object... arguments);
	void debug( String message, Object... arguments);
	void debug( String message, Throwable t, Object... arguments);

	void info( Throwable t, Object... arguments);
	void info( String message, Object... arguments);
	void info( String message, Throwable t, Object... arguments);

	void warning( Throwable t, Object... arguments);
	void warning( String message, Object... arguments);
	void warning( String message, Throwable t, Object... arguments);

	void severe( Throwable t, Object... arguments);
	void severe( String message, Object... arguments);
	void severe( String message, Throwable t, Object... arguments);

	void fatal( Throwable t, Object... arguments);
	void fatal( String message, Object... arguments);
	void fatal( String message, Throwable t, Object... arguments);
}
