package org.freecompany.util.multicaster;

public class NotificationMulticaster extends AbstractMulticaster< Notification> implements Notification {

	public static Notification DEFAULT = new LoggerNotification();
	public static Notification NULL = new NotificationAdapter();

	public void debug( Throwable t, Object... arguments) {
		a.debug( t, arguments);
		b.debug( t, arguments);
	}

	public void debug( String message, Object... arguments) {
		a.debug( message, arguments);
		b.debug( message, arguments);
	}

	public void debug( String message, Throwable t, Object... arguments) {
		a.debug( message, t, arguments);
		b.debug( message, t, arguments);
	}

	public void info( Throwable t, Object... arguments) {
		a.info( t, arguments);
		b.info( t, arguments);
	}

	public void info( String message, Object... arguments) {
		a.info( message, arguments);
		b.info( message, arguments);
	}

	public void info( String message, Throwable t, Object... arguments) {
		a.info( message, t, arguments);
		b.info( message, t, arguments);
	}

	public void warning( Throwable t, Object... arguments) {
		a.warning( t, arguments);
		b.warning( t, arguments);
	}

	public void warning( String message, Object... arguments) {
		a.warning( message, arguments);
		b.warning( message, arguments);
	}

	public void warning( String message, Throwable t, Object... arguments) {
		a.warning( message, t, arguments);
		b.warning( message, t, arguments);
	}

	public void severe( Throwable t, Object... arguments) {
		a.severe( t, arguments);
		b.severe( t, arguments);
	}

	public void severe( String message, Object... arguments) {
		a.severe( message, arguments);
		b.severe( message, arguments);
	}

	public void severe( String message, Throwable t, Object... arguments) {
		a.severe( message, t, arguments);
		b.severe( message, t, arguments);
	}

	public void fatal( Throwable t, Object... arguments) {
		a.fatal( t, arguments);
		b.fatal( t, arguments);
	}

	public void fatal( String message, Object... arguments) {
		a.fatal( message, arguments);
		b.fatal( message, arguments);
	}

	public void fatal( String message, Throwable t, Object... arguments) {
		a.fatal( message, t, arguments);
		b.fatal( message, t, arguments);
	}

	public static Notification logging( final Class< ?> clazz) {
		return new LoggerNotification( clazz.getName());
	}

	public static Notification logging() {
		return DEFAULT;
	}

	public static Notification empty() {
		return NULL;
	}

	public static Notification add( Notification a, Notification b) {
		return AbstractMulticaster.add( NotificationMulticaster.class, NULL, a, b);
	}

	public static Notification remove( Notification a, Notification b) {
		return AbstractMulticaster.remove( NULL, a, b);
	}
}
